%%clear all ;

function cubic_newton ()

  %% Starting value
  x(1) = 0.9 ;


  %% Set tolerance for the gradient
  eps = 1.e-7 ;


  printf ( "%4s %7s %10s %10s %8s\n", 
           "iter", "x", "f''", "f'", "f" ) ;
  k = 0 ;
  do
    k++ ;

    %% Compute gradients
    fmin = sTank   ( x(k) ) ;
    f_d  = sTank_d ( x(k) ) ;
    f_dd = sTank_dd( x(k) ) ;

    %% Next step
    x(k+1) = x(k) - f_d/f_dd ;

    printf ( "%4i, %7.4f %9.6f; %10.6f %10.6f\n", 
             k, x(k), f_dd, f_d, fmin ) ;

  until ( abs( f_d ) < eps | k > 99 ) 


endfunction


function surface = sTank (x)
  surface = x^3-3*x^2 ;
endfunction


function surface_d = sTank_d (x)
%%  surface = x^3-3x^2 ;
  surface_d = 3*x^2-6*x ;
endfunction


function surface_dd = sTank_dd (x)
%%  surface = x^3-3x^2 ;
%%  surface_d = 3x^2-6x ;
  surface_dd = 6*x-6 ;
endfunction
